<?php

namespace General\Services\LandingPage\ChargeFeedBack;

use General\Services\Config\ConfigService;
use Redis;

/**
 * 付费回传
 */
class ChargeFeedBack
{
    protected $service;
    protected $type;

    public function __construct()
    {
        $this->service = new ConfigService;
    }

    /**
     * 设置开关状态
     */
    public function setSwitchStatus(int $channel_id, int $status)
    {
        $this->service->saveConfig($channel_id, $this->type, $status);
        Redis::hSet('channel:setting:' . $channel_id, $this->type, $status);
    }

    /**
     * 获取开关状态
     */
    public function getSwitchStatus(int $channel_id)
    {
        $status = Redis::hGet('channel:setting:' . $channel_id, $this->type);
        if (!$status) {
            $status = $this->service->hasAuth($channel_id, $this->type);
            if ($status) {
                $this->setSwitchStatus($channel_id, $status);
            }
        }
        return $status;
    }

    /**
     * 同步开关状态
     */
    public function syncSwitchStatus(array $channel_ids, int $status)
    {
        foreach ($channel_ids as $channel_id) {
            $this->setSwitchStatus($channel_id, $status);
        }
    }
}
